<?php

namespace CustomerManagement\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfImageSensorAutoUploadRule ArrayType
 * @subpackage Arrays
 */
class ArrayOfImageSensorAutoUploadRule extends AbstractStructArrayBase
{
    /**
     * The ImageSensorAutoUploadRule
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \CustomerManagement\StructType\ImageSensorAutoUploadRule[]
     */
    public $ImageSensorAutoUploadRule;
    /**
     * Constructor method for ArrayOfImageSensorAutoUploadRule
     * @uses ArrayOfImageSensorAutoUploadRule::setImageSensorAutoUploadRule()
     * @param \CustomerManagement\StructType\ImageSensorAutoUploadRule[] $imageSensorAutoUploadRule
     */
    public function __construct(array $imageSensorAutoUploadRule = array())
    {
        $this
            ->setImageSensorAutoUploadRule($imageSensorAutoUploadRule);
    }
    /**
     * Get ImageSensorAutoUploadRule value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \CustomerManagement\StructType\ImageSensorAutoUploadRule[]|null
     */
    public function getImageSensorAutoUploadRule()
    {
        return isset($this->ImageSensorAutoUploadRule) ? $this->ImageSensorAutoUploadRule : null;
    }
    /**
     * This method is responsible for validating the values passed to the setImageSensorAutoUploadRule method
     * This method is willingly generated in order to preserve the one-line inline validation within the setImageSensorAutoUploadRule method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateImageSensorAutoUploadRuleForArrayConstraintsFromSetImageSensorAutoUploadRule(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfImageSensorAutoUploadRuleImageSensorAutoUploadRuleItem) {
            // validation for constraint: itemType
            if (!$arrayOfImageSensorAutoUploadRuleImageSensorAutoUploadRuleItem instanceof \CustomerManagement\StructType\ImageSensorAutoUploadRule) {
                $invalidValues[] = is_object($arrayOfImageSensorAutoUploadRuleImageSensorAutoUploadRuleItem) ? get_class($arrayOfImageSensorAutoUploadRuleImageSensorAutoUploadRuleItem) : sprintf('%s(%s)', gettype($arrayOfImageSensorAutoUploadRuleImageSensorAutoUploadRuleItem), var_export($arrayOfImageSensorAutoUploadRuleImageSensorAutoUploadRuleItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ImageSensorAutoUploadRule property can only contain items of type \CustomerManagement\StructType\ImageSensorAutoUploadRule, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ImageSensorAutoUploadRule value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\ImageSensorAutoUploadRule[] $imageSensorAutoUploadRule
     * @return \CustomerManagement\ArrayType\ArrayOfImageSensorAutoUploadRule
     */
    public function setImageSensorAutoUploadRule(array $imageSensorAutoUploadRule = array())
    {
        // validation for constraint: array
        if ('' !== ($imageSensorAutoUploadRuleArrayErrorMessage = self::validateImageSensorAutoUploadRuleForArrayConstraintsFromSetImageSensorAutoUploadRule($imageSensorAutoUploadRule))) {
            throw new \InvalidArgumentException($imageSensorAutoUploadRuleArrayErrorMessage, __LINE__);
        }
        if (is_null($imageSensorAutoUploadRule) || (is_array($imageSensorAutoUploadRule) && empty($imageSensorAutoUploadRule))) {
            unset($this->ImageSensorAutoUploadRule);
        } else {
            $this->ImageSensorAutoUploadRule = $imageSensorAutoUploadRule;
        }
        return $this;
    }
    /**
     * Add item to ImageSensorAutoUploadRule value
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\ImageSensorAutoUploadRule $item
     * @return \CustomerManagement\ArrayType\ArrayOfImageSensorAutoUploadRule
     */
    public function addToImageSensorAutoUploadRule(\CustomerManagement\StructType\ImageSensorAutoUploadRule $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \CustomerManagement\StructType\ImageSensorAutoUploadRule) {
            throw new \InvalidArgumentException(sprintf('The ImageSensorAutoUploadRule property can only contain items of type \CustomerManagement\StructType\ImageSensorAutoUploadRule, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ImageSensorAutoUploadRule[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \CustomerManagement\StructType\ImageSensorAutoUploadRule|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \CustomerManagement\StructType\ImageSensorAutoUploadRule|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \CustomerManagement\StructType\ImageSensorAutoUploadRule|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \CustomerManagement\StructType\ImageSensorAutoUploadRule|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \CustomerManagement\StructType\ImageSensorAutoUploadRule|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ImageSensorAutoUploadRule
     */
    public function getAttributeName()
    {
        return 'ImageSensorAutoUploadRule';
    }
}
